/*
 * The Seasar Software License, Version 1.1
 *
 * Copyright (c) 2003-2004 The Seasar Project. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or 
 * without modification, are permitted provided that the following 
 * conditions are met:
 *
 * 1. Redistributions of source code must retain the above 
 *    copyright notice, this list of conditions and the following 
 *    disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above 
 *    copyright notice, this list of conditions and the following 
 *    disclaimer in the documentation and/or other materials provided 
 *    with the distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgement:  
 *    "This product includes software developed by the 
 *    Seasar Project (http://www.seasar.org/)."
 *    Alternately, this acknowledgement may appear in the software
 *    itself, if and wherever such third-party acknowledgements 
 *    normally appear.
 *
 * 4. Neither the name "The Seasar Project" nor the names of its
 *    contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission of 
 *    the Seasar Project.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE SEASAR PROJECT 
 * OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
 * INCIDENTAL,SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY,OR TORT (INCLUDING 
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

import java.io.File;
import java.io.IOException;

/**
 * OOoLauncher (OpenOffice.org `[NX)
 * 
 * ̃vÓAOpenOffice.org풓̃`vOłB <br>
 * OpenOffice.org풓̋NEIS܂B OpenOffice.org 1.1.4 {+Windows XP
 * SP2œmF܂B <br>
 * ̃vOWindows XPȍ~ŗLł (Windows XP TASKKILLR}h𗘗pĂ܂) <br>
 * I[v\[X(Seasar Software License)̂ƂŌJĂ S2Joo x[XɃJX^}CYč쐬܂B <br>
 * ̂߁ACZX́uThe Seasar Software License, Version 1.1vɏ܂B
 * 
 * : {IɃXbhZ[tł́u܂vBȂȂ瑊肪vZXł邩łB̃NX̗p҂VOœ삷悤ɐ䂵ĂB
 * 
 * @author makotan: http://d.hatena.ne.jp/makotan/ (IWi)
 * @author igapyon: tosiki.iga@nifty.ne.jp (HĒ܂)
 * @version 2005/03/04 OOoLaunchero[W쐬
 */
public class OOoLauncher {
	/**
	 * OpenOffice.org̃vZXL܂B
	 */
	private Process procOOo = null;

	/**
	 * OpenOffice.orgT[oƂċN邽߂̈B
	 * Windows̏ꍇSolaris̏ꍇB
	 */
	private static final String oooExecParam = "-accept=socket,port=8100;urp;StarOffice.ServiceManager";

	/**
	 * OpenOffice.orgvZX~邽߂̃R}hB
	 */
	// Solaris̏ꍇ
	public static final String[] OOO_KILL = { "pkill", "soffice" };

	// Windows̏ꍇ
	// public static final String[] OOO_KILL = { "taskkill.exe", "/f", "/im",
	// "soffice.exe" };

	/**
	 * OpenOffice.orgNƂ̑ҋ@Ԃw肵܂B
	 */
	public static final int WAIT_MILLISEC_FOR_SOFFICE_LAUNCH = 1000;

	/**
	 * OpenOffice.orgKILLƂ̑ҋ@Ԃw肵܂B
	 */
	public static final int WAIT_MILLISEC_FOR_SOFFICE_KILL = 1000;

	/**
	 * OpenOffice.orgvZXN܂B <br>
	 * O ensureStop()\bhĂяoĂƁAsvȃvZX̑|łāAmłƍl܂B
	 * 
	 * @param moduleFullPath
	 *            OpenOffice.org̃W[pX <br>
	 *            <code>
	 *            ex. ["C:\\Program Files\\OpenOffice.org1.1.4\\program\\soffice.exe"]<code>
	 */
	public void start(final String oooExecPath) {
		File fileCheck = new File(oooExecPath);
		if (fileCheck.exists() == false) {
			throw new IllegalArgumentException("OpenOffice.org[hW[ ["
					+ fileCheck + "] ̃t@C܂ł.");
		}

		try {
			System.out.println("OpenOffice.org[hW[ [" + oooExecPath + "] ["
					+ oooExecParam + "] N܂.");
			procOOo = Runtime.getRuntime().exec(
					new String[] { oooExecPath, oooExecParam });
		} catch (IOException ex) {
			throw new IllegalArgumentException("OpenOffice.org[hW[ ["
					+ oooExecPath + "] [" + oooExecParam + "] ̋NɎs܂.: "
					+ ex.toString());
		}
		try {
			Thread.sleep(WAIT_MILLISEC_FOR_SOFFICE_LAUNCH);
		} catch (InterruptedException ex) {
			System.out.println("OpenOfficevZXN̋K莞Ԃ̑ҋ@Ɋ荞݂܂.: "
					+ ex.toString());
			ex.printStackTrace();
		}
	}

	/**
	 * OpenOffice.orgvZX~Ă邱Ƃ̔O܂B
	 */
	public void ensureStop() {
		try {
			// TASKKILLpH
			Process procKill = Runtime.getRuntime().exec(OOO_KILL);
			procKill.waitFor();
		} catch (IOException ex1) {
			System.out
					.println("OpenOffice.org̋~R}h ["
							+ OOO_KILL
							+ "] s܂B"
							+ "Windows 2000ȑOOSɂāATASKKILLR}h͎ĂȂ̂ŁÃR}h͎s܂B");
		} catch (InterruptedException ex) {
			System.out
					.println("OpenOfficevZX~R}h̋N̋K莞Ԃ̑ҋ@Ɋ荞݂܂.: "
							+ ex.toString());
			ex.printStackTrace();
		}
	}

	/**
	 * OpenOffice.orgvZX~܂B
	 */
	public void stop() {
		if (procOOo == null) {
			return;
		}

		procOOo.destroy();

		// DestoryAwbҋ@܂B
		try {
			Thread.sleep(WAIT_MILLISEC_FOR_SOFFICE_KILL);
		} catch (InterruptedException ex) {
			System.out.println("OpenOfficevZX~˗s̋K莞Ԃ̑ҋ@Ɋ荞݂܂.: "
					+ ex.toString());
			ex.printStackTrace();
		}

		// mɒ~܂B
		ensureStop();

		try {
			// OpenOffice.orgvZX̊S~mF܂B
			int retcode = procOOo.waitFor();
			System.out.println("OpenOfficevZX ߂l[" + retcode + "]ŏI܂.");
		} catch (InterruptedException ex) {
			// waitFor̗O͖܂B
			System.out.println("OpenOfficevZXI҂̍ۂɊ荞݂܂.: "
					+ ex.toString());
			ex.printStackTrace();
		}

		procOOo = null;
	}
}