/*
 * The Seasar Software License, Version 1.1
 *
 * Copyright (c) 2003-2004 The Seasar Project. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or 
 * without modification, are permitted provided that the following 
 * conditions are met:
 *
 * 1. Redistributions of source code must retain the above 
 *    copyright notice, this list of conditions and the following 
 *    disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above 
 *    copyright notice, this list of conditions and the following 
 *    disclaimer in the documentation and/or other materials provided 
 *    with the distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgement:  
 *    "This product includes software developed by the 
 *    Seasar Project (http://www.seasar.org/)."
 *    Alternately, this acknowledgement may appear in the software
 *    itself, if and wherever such third-party acknowledgements 
 *    normally appear.
 *
 * 4. Neither the name "The Seasar Project" nor the names of its
 *    contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission of 
 *    the Seasar Project.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE SEASAR PROJECT 
 * OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
 * INCIDENTAL,SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY,OR TORT (INCLUDING 
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

import junit.framework.TestCase;

/**
 * OOoLauncher (OpenOffice.org `[NX)̃eXgNX
 * 
 * ̃vÓAOpenOffice.org풓̃`vOłB <br>
 * OpenOffice.org풓̋NEIS܂B OpenOffice.org 1.1.4 {+Windows XP
 * SP2œmF܂B <br>
 * ̃vOWindows XPȍ~ŗLł (Windows XP TASKKILLR}h𗘗pĂ܂) <br>
 * I[v\[X(Seasar Software License)̂ƂŌJĂ S2Joo x[XɃJX^}CYč쐬܂B <br>
 * ̂߁ACZX́uThe Seasar Software License, Version 1.1vɏ܂B
 * 
 * : {IɃXbhZ[tł́u܂vBȂȂ瑊肪vZXł邩łB̃NX̗p҂VOœ삷悤ɐ䂵ĂB
 * 
 * @author makotan: http://d.hatena.ne.jp/makotan/ (IWi)
 * @author tosiki.iga@nifty.ne.jp (HĒ܂)
 * @version 2005/03/04 OOoLaunchero[W쐬
 */
public class OOoLauncherTest extends TestCase {

	//private static final String OPEN_OFFICE_LOAD_MODULE = "D:\\Program Files\\OpenOffice.org1.1.4\\program\\soffice.exe";
	private static final String OPEN_OFFICE_LOAD_MODULE = "/usr/local/OpenOffice.org1.1.4/program/soffice";

	public void testStart() throws InterruptedException {
		OOoLauncher launcher = new OOoLauncher();
		System.out.println("OpenOffice.orgNĂƂĂ~܂.");
		launcher.ensureStop();
		System.out.println("OpenOffice.orgN܂.");
		launcher.start(OPEN_OFFICE_LOAD_MODULE);
		System.out.println("10bҋ@܂Bʏ͂JooConverter𗘗p܂.");
		Thread.sleep(10000);
		System.out.println("OpenOffice.org~܂.");
		launcher.stop();
		System.out.println("I܂.");
	}
}